package martin;

import java.util.ArrayList;
import java.util.concurrent.ConcurrentLinkedQueue;
import java.util.concurrent.atomic.AtomicLong;

/**
 * Logger
 *
 * @author Martin Dale Lyness
 * @since 8/27/12
 */
public class MyLog {
    private static ConcurrentLinkedQueue<String> msgs = new ConcurrentLinkedQueue<String>();
    private static AtomicLong lastMsg = new AtomicLong(System.currentTimeMillis());
    public static void log(String msg) {
        long time = System.currentTimeMillis();
        msgs.offer("["+(time - lastMsg.getAndSet(time))+"] " + msg);
    }

    public static void flush() {
        ArrayList<String> msgsCopy;
        synchronized (msgs) {
            msgsCopy = new ArrayList<String>(msgs.size());
            msgsCopy.addAll(msgs);
            msgs.clear();
        }
        for(String msg: msgsCopy)
            System.out.println(msg);
    }
}
