package martin.jbpm.ext;

/**
 * JBPMTaskHandler
 *
 * @author Martin Dale Lyness
 * @since 8/27/12
 */

import martin.tasks.Task;
import org.drools.process.instance.WorkItemHandler;
import org.drools.runtime.process.WorkItem;
import org.drools.runtime.process.WorkItemManager;

public class JBPMTaskHandler implements WorkItemHandler {
    private Task task;

    @Override
    public void executeWorkItem(WorkItem workItem, WorkItemManager manager) {
        try {
            getTask().doTask(workItem.getProcessInstanceId());
        } catch (Exception e) {
            e.printStackTrace();  //To change body of catch statement use File | Settings | File Templates.
            System.exit(-1);
        }
    }

    @Override
    public void abortWorkItem(WorkItem workItem, WorkItemManager manager) {
        manager.abortWorkItem(workItem.getId());
    }

    public Task getTask() {
        return task;
    }

    public void setTask(Task task) {
        this.task = task;
    }
}