package martin.persistence;

import martin.persistence.dao.MyTableDAO;
import org.springframework.transaction.annotation.Transactional;

import javax.inject.Inject;
import javax.inject.Named;
import javax.inject.Singleton;
import java.util.UUID;

/**
 * PersistService
 *
 * @author Martin Dale Lyness
 * @since 8/27/12
 */
@Named
@Singleton
public class PersistService {
    private @Inject MyTableDAO myTableDAO;

    @Transactional(value = "core")
    public void createEntry() {
        MyTable entry = new MyTable();
        entry.setId(UUID.randomUUID().toString());
        myTableDAO.save(entry);
    }
}
