package martin.persistence.dao;

import martin.persistence.MyTable;

import javax.inject.Named;
import javax.inject.Singleton;
import javax.persistence.EntityManager;
import javax.persistence.PersistenceContext;
import javax.persistence.PersistenceUnit;
import javax.persistence.Query;
import java.util.List;

/**
 * MyTableDAO
 *
 * @author Martin Dale Lyness
 * @since 8/27/12
 */
@Named
@Singleton
public class MyTableDAO {
    @PersistenceContext(unitName = "martin")
    private EntityManager em;

    public void save(MyTable entry) {
        em.persist(entry);
    }

    public List<MyTable> read(String uuid) {
        Query q = em.createQuery("from MyTable where id = :id");
        q.setParameter("id", uuid);
        return q.getResultList();
    }
}
