package martin.tasks;

import martin.jbpm.ext.JBPMWorkflowService;
import martin.persistence.PersistService;
import org.apache.commons.lang.math.RandomUtils;
import org.springframework.transaction.annotation.Transactional;

import javax.inject.Inject;
import javax.inject.Named;
import javax.inject.Singleton;
import java.util.concurrent.ConcurrentLinkedQueue;

/**
 * AsynchrounousTask
 *
 * @author Martin Dale Lyness
 * @since 8/27/12
 */
@Named
@Singleton
public class AsynchronousTask implements Task {
    @Inject private JBPMWorkflowService jbpmWorkflowService;
    @Inject private PersistService persistService;
    private ConcurrentLinkedQueue<Long> queue = new ConcurrentLinkedQueue<Long>();

    public AsynchronousTask() {
        new Thread("async-queue-proc") {
            public void run() {
                try {
                    checkQueue: for(;;) {
                        Long jbpmProcessId = queue.poll();
                        if(jbpmProcessId==null) {
                            try { Thread.sleep(1); } catch (InterruptedException e) { System.exit(0); }
                            continue checkQueue;
                        }
                        persistService.createEntry();
                        //try { Thread.sleep(RandomUtils.nextInt(5000)); } catch (InterruptedException e) { System.exit(0); }
                        jbpmWorkflowService.completeWorkItem(jbpmProcessId);
                    }
                } catch(Throwable t) {
                    t.printStackTrace();
                    System.exit(-1);
                }
            }
        }.start();
    }

    //@Transactional("core")
    @Override public Long doTask(Long jbpmProcessId) throws Exception {
        queue.offer(jbpmProcessId);
        return jbpmProcessId;
    }
}
