package martin.tasks;

import martin.jbpm.ext.JBPMWorkflowService;
import martin.persistence.PersistService;
import org.apache.commons.lang.math.RandomUtils;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;

import javax.inject.Inject;
import javax.inject.Named;
import javax.inject.Singleton;

/**
 * SynchronousTask
 *
 * @author Martin Dale Lyness
 * @since 8/27/12
 */
@Named
@Singleton
public class SynchronousTask implements Task {
    @Inject private JBPMWorkflowService jbpmWorkflowService;
    @Inject private PersistService persistService;

    @Override
    @Transactional(value="core", propagation = Propagation.REQUIRES_NEW)
    public Long doTask(Long jbpmProcessId) throws Exception {
        //Thread.sleep(RandomUtils.nextInt(1000));
        persistService.createEntry();
        return jbpmWorkflowService.completeWorkItem(jbpmProcessId);
    }
}
